/* ckaliases - verify syntax of sendmail-style alias files
   Copyright (C) 2005 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301 USA. */

extern char *file_name;
extern int line_num;

void init_lex();
void lex_debug(int n);
void openaliases(char *name);
void openaliases_prefix(char *prefix, char *name);

struct string_list {
	struct string_list *next;
	char *str;
};

typedef struct slist {
	struct string_list *head, *tail;
	int count;
} SLIST;

void slist_add(SLIST **plist, char *str);
void slist_append(SLIST **pdst, SLIST *src);
char *slist_member(SLIST *plist, char *name);
void slist_destroy(SLIST **plist);

void read_include(SLIST **plist, char *name);

void regalias(char *name, SLIST *exp);
void begin_aliases(void);
void end_aliases(void);

void error(char *fmt, ...);

extern SLIST *cw_list;
extern int verbose;
